xenial
[build.git] / lbuild-initvm.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
5 0<&-
6
7 #shopt -s huponexit
8
9 COMMAND=$(basename $0)
10 DIRNAME=$(dirname $0)
11 BUILD_DIR=$(pwd)
12
13 # pkgs parsing utilities + lbuild-bridge.sh
14 export PATH=$(dirname $0):$PATH
15
16 # old guests have e.g. mount in /bin but this is no longer part of 
17 # the standard PATH in recent hosts after usrmove, so let's keep it simple
18 export PATH=$PATH:/bin:/sbin
19
20 . build.common
21
22 # xxx fixme : we pass $lxc around in functions,
23 # but in fact then we use lxc_root which is a global..
24 # it works, but this really is poor practice
25 # we should have an lxc_root function instead
26 function lxcroot () {
27     lxc=$1; shift
28     echo /vservers/$lxc
29 }
30
31 # XXX fixme : when creating a 32bits VM we need to call linux32 as appropriate...s
32
33 DEFAULT_FCDISTRO=f23
34 DEFAULT_PLDISTRO=lxc
35 DEFAULT_PERSONALITY=linux64
36 DEFAULT_MEMORY=3072
37
38 ##########
39 # constant
40 PUBLIC_BRIDGE=br0
41
42 # the network interface name as seen from the container
43 VIF_GUEST=eth0
44
45 ##########
46 FEDORA_MIRROR_BASE="http://mirror.onelab.eu/fedora/"
47 FEDORA_MIRROR_KEYS="http://mirror.onelab.eu/keys/"
48 FEDORA_PREINSTALLED="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
49 DEBIAN_PREINSTALLED="openssh-server openssh-client"
50
51 ########## networking utilities
52 function gethostbyname () {
53     hostname=$1
54     python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
55 }
56
57 # e.g. 21 -> 255.255.248.0
58 function masklen_to_netmask () {
59     masklen=$1; shift
60     python <<EOF
61 import sys
62 masklen=$masklen
63 if not (masklen>=1 and masklen<=32): 
64   print "Wrong masklen",masklen
65   exit(1)
66 result=[]
67 for i in range(4):
68     if masklen>=8:
69        result.append(8)
70        masklen-=8
71     else:
72        result.append(masklen)
73        masklen=0
74 print ".".join([ str(256-2**(8-i)) for i in result ])
75   
76 EOF
77 }
78
79 ##############################
80 # return yum or debootstrap
81 function package_method () {
82     fcdistro=$1; shift
83     case $fcdistro in
84         f[0-9]*|centos[0-9]*|sl[0-9]*)
85             echo yum ;;
86         wheezy|jessie|precise|trusty|utopic|vivid|wily|xenial)
87             echo debootstrap ;;
88         *)
89             echo Unknown distro $fcdistro ;;
90     esac 
91 }
92
93 # return arch from debian distro and personality
94 function canonical_arch () {
95     personality=$1; shift
96     fcdistro=$1; shift
97     case $(package_method $fcdistro) in
98         yum)
99             case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
100         debootstrap)
101             case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
102         *)
103             echo Unknown-arch-3 ;;
104     esac
105 }
106
107 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
108 function almost_empty () { 
109     dir="$1"; shift ; 
110     # non existing is fine
111     [ ! -d $dir ] && return 0; 
112     # need to have at most one file
113     count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
114 }
115
116 ##############################
117 function fedora_install() {
118     set -x
119     set -e
120
121     lxc=$1; shift
122     lxc_root=$(lxcroot $lxc)
123
124     cache=/var/cache/lxc/fedora/$arch/$release
125     mkdir -p $cache
126     
127     (
128         flock --exclusive --timeout 60 200 || { echo "Cache repository is busy." ; return 1 ; }
129
130         if [ ! -e "$cache/rootfs" ]; then
131             echo "Getting cache download in $cache/rootfs ... "
132             fedora_download $cache || { echo "Failed to download 'fedora base'"; return 1; }
133         else
134             echo "Updating cache $cache/rootfs ..."
135             if ! yum --installroot $cache/rootfs --releasever $release -y --nogpgcheck update ; then
136                 echo "Failed to update 'fedora base', continuing with last known good cache"
137             else
138                 echo "Update finished"
139             fi
140         fi
141
142         echo "Filling $lxc_root from $cache/rootfs ... "
143         rsync -a $cache/rootfs/ $lxc_root/
144         
145         return 0
146
147         ) 200> $cache/lock
148
149     return $?
150 }
151
152 function fedora_download() {
153     set -x
154
155     cache=$1; shift
156
157     # check the mini fedora was not already downloaded
158     INSTALL_ROOT=$cache/partial
159     echo $INSTALL_ROOT
160
161     # download a mini fedora into a cache
162     echo "Downloading fedora minimal ..."
163
164     mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
165
166     mkdir -p $INSTALL_ROOT/etc/yum.repos.d   
167     mkdir -p $INSTALL_ROOT/dev
168     mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
169     mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
170
171     # copy yum config and repo files
172     cp /etc/yum.conf $INSTALL_ROOT/etc/
173     cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
174
175     # append fedora repo files with desired $release and $basearch
176     for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
177       sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
178     done 
179
180     MIRROR_URL=$FEDORA_MIRROR_BASE/releases/$release/Everything/$arch/os
181     RELEASE_URL1="$MIRROR_URL/Packages/fedora-release-$release-1.noarch.rpm"
182     # with fedora18 the rpms are scattered by first name
183     # first try the second version of fedora-release first
184     RELEASE_URL2="$MIRROR_URL/Packages/f/fedora-release-$release-2.noarch.rpm"
185     RELEASE_URL3="$MIRROR_URL/Packages/f/fedora-release-$release-1.noarch.rpm"
186    
187     RELEASE_TARGET=$INSTALL_ROOT/fedora-release-$release.noarch.rpm
188     found=""
189     for attempt in $RELEASE_URL1 $RELEASE_URL2 $RELEASE_URL3; do
190         if curl -f $attempt -o $RELEASE_TARGET ; then
191             echo "Retrieved $attempt"
192             found=true
193             break
194         else
195             echo "Failed attempt $attempt"
196         fi
197     done
198     [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
199     
200     mkdir -p $INSTALL_ROOT/var/lib/rpm
201     rpm --root $INSTALL_ROOT  --initdb
202     # when installing f12 this apparently is already present, so ignore result
203     rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-$release.noarch.rpm || :
204     # however f12 root images won't get created on a f18 host
205     # (the issue here is the same as the one we ran into when dealing with a vs-box)
206     # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
207     # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts 
208     #          with file from package filesystem-2.4.30-2.fc12.x86_64
209     # in fact this was - of course - allowed by f12's rpm but later on a fix was made 
210     #   http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
211     # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
212     # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
213
214     YUM="yum --installroot=$INSTALL_ROOT --releasever=$release --nogpgcheck -y"
215     echo "$YUM install $FEDORA_PREINSTALLED"
216     $YUM install $FEDORA_PREINSTALLED || { echo "Failed to download rootfs, aborting." ; return 1; }
217
218     mv "$INSTALL_ROOT" "$cache/rootfs"
219     echo "Download complete."
220
221     return 0
222 }
223
224 ##############################
225 function fedora_configure() {
226
227     set -x
228     set -e
229
230     lxc=$1; shift
231     lxc_root=$(lxcroot $lxc)
232
233     # disable selinux in fedora
234     mkdir -p $lxc_root/selinux
235     echo 0 > $lxc_root/selinux/enforce
236
237     # set the hostname
238     case "$fcdistro" in 
239         f18|f2?)
240             cat <<EOF > ${lxc_root}/etc/sysconfig/network
241 NETWORKING=yes
242 EOF
243             cat <<EOF > ${lxc_root}/etc/hostname
244 $GUEST_HOSTNAME
245 EOF
246             echo ;;
247         *)
248             cat <<EOF > ${lxc_root}/etc/sysconfig/network
249 NETWORKING=yes
250 HOSTNAME=$GUEST_HOSTNAME
251 EOF
252             # set minimal hosts
253             cat <<EOF > $lxc_root/etc/hosts
254 127.0.0.1 localhost $GUEST_HOSTNAME
255 EOF
256             echo ;;
257     esac
258
259     dev_path="${lxc_root}/dev"
260     rm -rf $dev_path
261     mkdir -p $dev_path
262     mknod -m 666 ${dev_path}/null c 1 3
263     mknod -m 666 ${dev_path}/zero c 1 5
264     mknod -m 666 ${dev_path}/random c 1 8
265     mknod -m 666 ${dev_path}/urandom c 1 9
266     mkdir -m 755 ${dev_path}/pts
267     mkdir -m 1777 ${dev_path}/shm
268     mknod -m 666 ${dev_path}/tty c 5 0
269     mknod -m 666 ${dev_path}/tty0 c 4 0
270     mknod -m 666 ${dev_path}/tty1 c 4 1
271     mknod -m 666 ${dev_path}/tty2 c 4 2
272     mknod -m 666 ${dev_path}/tty3 c 4 3
273     mknod -m 666 ${dev_path}/tty4 c 4 4
274     mknod -m 600 ${dev_path}/console c 5 1
275     mknod -m 666 ${dev_path}/full c 1 7
276     mknod -m 600 ${dev_path}/initctl p
277     mknod -m 666 ${dev_path}/ptmx c 5 2
278
279     if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
280         fedora_configure_init $lxc
281     else
282         fedora_configure_systemd $lxc
283     fi
284
285     guest_ifcfg=${lxc_root}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
286     ( [ -n "$NAT_MODE" ] && write_guest_ifcfg_natip || write_guest_ifcfg_publicip ) > $guest_ifcfg
287
288     [ -z "$IMAGE" ] && fedora_configure_yum $lxc $fcdistro $pldistro
289
290     return 0
291 }
292
293 function fedora_configure_init() {
294     set -e
295     set -x
296     lxc=$1; shift
297     lxc_root=$(lxcroot $lxc)
298
299     sed -i 's|.sbin.start_udev||' ${lxc_root}/etc/rc.sysinit
300     sed -i 's|.sbin.start_udev||' ${lxc_root}/etc/rc.d/rc.sysinit
301     # don't mount devpts, for pete's sake
302     sed -i 's/^.*dev.pts.*$/#\0/' ${lxc_root}/etc/rc.sysinit
303     sed -i 's/^.*dev.pts.*$/#\0/' ${lxc_root}/etc/rc.d/rc.sysinit
304     chroot ${lxc_root} $personality chkconfig udev-post off
305     chroot ${lxc_root} $personality chkconfig network on
306 }
307
308 # this code of course is for guests that do run on systemd
309 function fedora_configure_systemd() {
310     set -e
311     set -x
312     lxc=$1; shift
313     lxc_root=$(lxcroot $lxc)
314
315     # so ignore if we can't find /etc/systemd at all 
316     [ -d ${lxc_root}/etc/systemd ] || return 0
317     # otherwise let's proceed
318     ln -sf /lib/systemd/system/multi-user.target ${lxc_root}/etc/systemd/system/default.target
319     touch ${lxc_root}/etc/fstab
320     ln -sf /dev/null ${lxc_root}/etc/systemd/system/udev.service
321 # Thierry - Feb 2013 relying on getty is looking for trouble
322 # so, turning getty off for now instead
323 #    sed -i 's/After=dev-%i.device/After=/' ${lxc_root}/lib/systemd/system/getty\@.service
324     ln -sf /dev/null ${lxc_root}/etc/systemd/system/"getty@.service"
325     rm -f ${lxc_root}/etc/systemd/system/getty.target.wants/*service || :
326 # can't seem to handle this one with systemctl
327     chroot ${lxc_root} $personality chkconfig network on
328 }
329
330 # overwrite container yum config
331 function fedora_configure_yum () {
332     set -x 
333     set -e 
334     trap failure ERR INT
335
336     lxc=$1; shift
337     fcdistro=$1; shift
338     pldistro=$1; shift
339
340     lxc_root=$(lxcroot $lxc)
341     # rpm --rebuilddb
342     chroot ${lxc_root} $personality rpm --rebuilddb
343
344     echo "Initializing yum.repos.d in $lxc"
345     rm -f $lxc_root/etc/yum.repos.d/*
346
347     cat > $lxc_root/etc/yum.repos.d/building.repo <<EOF
348 [fedora]
349 name=Fedora \$releasever - \$basearch
350 baseurl=$FEDORA_MIRROR_BASE/releases/\$releasever/Everything/\$basearch/os/
351 enabled=1
352 metadata_expire=7d
353 gpgcheck=1
354 gpgkey=$FEDORA_MIRROR_KEYS/RPM-GPG-KEY-fedora-$release-primary
355
356 [updates]
357 name=Fedora \$releasever - \$basearch - Updates
358 baseurl=$FEDORA_MIRROR_BASE/updates/\$releasever/\$basearch/
359 enabled=1
360 metadata_expire=7d
361 gpgcheck=1
362 gpgkey=$FEDORA_MIRROR_KEYS/RPM-GPG-KEY-fedora-$release-primary
363 EOF
364
365     # for using this script as a general-purpose lxc creation wrapper
366     # just mention 'none' as the repo url
367     if [ -n "$REPO_URL" ] ; then
368         if [ ! -d $lxc_root/etc/yum.repos.d ] ; then
369             echo "WARNING : cannot create myplc repo"
370         else
371             # exclude kernel from fedora repos 
372             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
373             for repo in $lxc_root/etc/yum.repos.d/* ; do
374                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude" 
375             done
376             # the build repo is not signed at this stage
377             cat > $lxc_root/etc/yum.repos.d/myplc.repo <<EOF
378 [myplc]
379 name= MyPLC
380 baseurl=$REPO_URL
381 enabled=1
382 gpgcheck=0
383 EOF
384         fi
385     fi
386 }    
387
388 ##############################
389 # apparently ubuntu exposes a mirrors list by country at
390 # http://mirrors.ubuntu.com/mirrors.txt
391 # need to specify the right mirror for debian variants like ubuntu and the like
392 function debian_mirror () {
393     fcdistro=$1; shift
394     case $fcdistro in
395         wheezy|jessie) 
396             echo http://ftp2.fr.debian.org/debian/ ;;
397         precise|trusty|utopic|vivid|wily|xenial) 
398 #           echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
399             echo http://www-ftp.lip6.fr/pub/linux/distributions/Ubuntu/archive/ ;;
400         *) echo unknown distro $fcdistro; exit 1;;
401     esac
402 }
403
404 function debian_install () {
405     set -e
406     set -x
407     lxc=$1; shift
408     lxc_root=$(lxcroot $lxc)
409     mkdir -p $lxc_root
410     arch=$(canonical_arch $personality $fcdistro)
411     mirror=$(debian_mirror $fcdistro)
412     debootstrap --no-check-gpg --arch $arch $fcdistro $lxc_root $mirror
413     # just like with fedora we ensure a few packages get installed as well
414     # not started yet
415     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get update"
416     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get -y install $DEBIAN_PREINSTALLED"
417     chroot ${lxc_root} $personality apt-get update
418     chroot ${lxc_root} $personality apt-get -y install $DEBIAN_PREINSTALLED
419     # configure hostname
420     cat <<EOF > ${lxc_root}/etc/hostname
421 $GUEST_HOSTNAME
422 EOF
423     
424 }
425
426 function debian_configure () {
427     guest_interfaces=${lxc_root}/etc/network/interfaces
428     ( [ -n "$NAT_MODE" ] && write_guest_interfaces_natip || write_guest_interfaces_publicip ) > $guest_interfaces
429 }
430
431 function write_guest_interfaces_natip () {
432     cat <<EOF
433 auto $VIF_GUEST
434 iface $VIF_GUEST inet dhcp
435 EOF
436 }
437
438 function write_guest_interfaces_publicip () {
439     cat <<EOF
440 auto $VIF_GUEST
441 iface $VIF_GUEST inet static
442 address $GUEST_IP
443 netmask $NETMASK
444 gateway $GATEWAY
445 EOF
446 }
447 ##############################
448 function setup_lxc() {
449
450     set -x
451     set -e
452     #trap failure ERR INT
453
454     lxc=$1; shift
455     fcdistro=$1; shift
456     pldistro=$1; shift
457     personality=$1; shift
458
459     lxc_root=$(lxcroot $lxc)
460
461     # create lxc container 
462     
463     pkg_method=$(package_method $fcdistro)
464     case $pkg_method in
465         yum)
466             if [ -z "$IMAGE" ]; then
467                 fedora_install $lxc ||  { echo "failed to install fedora root image"; exit 1 ; }
468                 # this appears to be safer; observed in Jan. 2016 on a f23 host and a f14 cached image
469                 # we were getting this message when attempting the first chroot yum install
470                 # rpmdb: Program version 4.8 doesn't match environment version 5.3
471                 chroot $(lxcroot $lxc) $personality rm -rf /var/lib/rpm/__db.00{0,1,2,3,4,5,6,7,8,9}
472                 chroot $(lxcroot $lxc) $personality rpm --rebuilddb
473             fi
474             fedora_configure $lxc || { echo "failed to configure fedora for a container"; exit 1 ; }
475             ;;
476         debootstrap)
477             if [ -z "$IMAGE" ]; then
478                 debian_install $lxc || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
479             fi
480             debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
481             ;;
482         *)
483             echo "$COMMAND:: unknown package_method - exiting"
484             exit 1
485             ;;
486     esac
487
488     # Enable cgroup -- xxx -- is this really useful ?
489     [ -d $lxc_root/cgroup ] || mkdir $lxc_root/cgroup
490     
491     ### set up resolv.conf from host
492     # ubuntu precise and on, /etc/resolv.conf is a symlink to ../run/resolvconf/resolv.conf
493     [ -h $lxc_root/etc/resolv.conf ] && rm -f $lxc_root/etc/resolv.conf
494     cp /etc/resolv.conf $lxc_root/etc/resolv.conf
495     ### and /etc/hosts for at least localhost
496     [ -f $lxc_root/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $lxc_root/etc/hosts
497     
498     # grant ssh access from host to guest
499     mkdir -p $lxc_root/root/.ssh
500     cat /root/.ssh/id_rsa.pub >> $lxc_root/root/.ssh/authorized_keys
501     chmod 700 $lxc_root/root/.ssh
502     chmod 600 $lxc_root/root/.ssh/authorized_keys
503
504     # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
505     config_xml=/tmp/$lxc.xml
506     ( [ -n "$NAT_MODE" ] && write_lxc_xml_natip $lxc || write_lxc_xml_publicip $lxc ) > $config_xml
507     
508     # define lxc container for libvirt
509     virsh -c lxc:/// define $config_xml
510
511     return 0
512 }
513
514 # this part does not belong in a domain any more
515 # but goes in a network object of its own existence
516 #      <network>
517 #        <name>host-bridge</name>
518 #        <forward mode="bridge"/>
519 #        <bridge name="br0"/>
520 #      </network>
521 #
522
523 function write_lxc_xml_publicip () {
524     lxc=$1; shift
525     lxc_root=$(lxcroot $lxc)
526     cat <<EOF
527 <domain type='lxc'>
528   <name>$lxc</name>
529   <memory>$MEMORY</memory>
530   <os>
531     <type arch='$arch2'>exe</type>
532     <init>/sbin/init</init>
533   </os>
534   <features>
535     <acpi/>
536   </features>
537   <vcpu>1</vcpu>
538   <clock offset='utc'/>
539   <on_poweroff>destroy</on_poweroff>
540   <on_reboot>restart</on_reboot>
541   <on_crash>destroy</on_crash>
542   <devices>
543     <emulator>/usr/libexec/libvirt_lxc</emulator>
544     <filesystem type='mount'>
545       <source dir='$lxc_root'/>
546       <target dir='/'/>
547     </filesystem>
548     <interface type="bridge">
549       <source bridge="$PUBLIC_BRIDGE"/>
550       <target dev='$VIF_HOST'/>
551     </interface>
552     <console type='pty' />
553   </devices>
554 </domain>
555 EOF
556 }
557
558 # grant build guests the ability to do mknods
559 function write_lxc_xml_natip () { 
560     lxc=$1; shift
561     lxc_root=$(lxcroot $lxc)
562     cat <<EOF
563 <domain type='lxc'>
564   <name>$lxc</name>
565   <memory>$MEMORY</memory>
566   <os>
567     <type arch='$arch2'>exe</type>
568     <init>/sbin/init</init>
569   </os>
570   <features>
571     <acpi/>
572     <capabilities policy='default'>
573       <mknod state='on'/>
574     </capabilities>
575   </features>
576   <vcpu>1</vcpu>
577   <clock offset='utc'/>
578   <on_poweroff>destroy</on_poweroff>
579   <on_reboot>restart</on_reboot>
580   <on_crash>destroy</on_crash>
581   <devices>
582     <emulator>/usr/libexec/libvirt_lxc</emulator>
583     <filesystem type='mount'>
584       <source dir='$lxc_root'/>
585       <target dir='/'/>
586     </filesystem>
587     <interface type="network">
588       <source network="default"/>
589     </interface>
590     <console type='pty' />
591   </devices>
592 </domain>
593 EOF
594 }
595
596 # this one is dhcp-based
597 function write_guest_ifcfg_natip () {
598     cat <<EOF
599 DEVICE=$VIF_GUEST
600 BOOTPROTO=dhcp
601 ONBOOT=yes
602 NM_CONTROLLED=no
603 TYPE=Ethernet
604 MTU=1500
605 EOF
606 }
607
608 # use fixed GUEST_IP as specified by GUEST_HOSTNAME
609 function write_guest_ifcfg_publicip () {
610     cat <<EOF
611 DEVICE=$VIF_GUEST
612 BOOTPROTO=static
613 ONBOOT=yes
614 HOSTNAME=$GUEST_HOSTNAME
615 IPADDR=$GUEST_IP
616 NETMASK=$NETMASK
617 GATEWAY=$GATEWAY
618 NM_CONTROLLED=no
619 TYPE=Ethernet
620 MTU=1500
621 EOF
622 }
623
624 function devel_or_test_tools () {
625
626     set -x 
627     set -e 
628     trap failure ERR INT
629
630     lxc=$1; shift
631     fcdistro=$1; shift
632     pldistro=$1; shift
633     personality=$1; shift
634
635     lxc_root=$(lxcroot $lxc)
636
637     pkg_method=$(package_method $fcdistro)
638
639     pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
640
641     ### install individual packages, then groups
642     # get target arch - use uname -i here (we want either x86_64 or i386)
643    
644     lxc_arch=$(chroot ${lxc_root} $personality uname -i)
645     # on debian systems we get arch through the 'arch' command
646     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot ${lxc_root} $personality arch)
647
648     packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
649     groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
650
651     case "$pkg_method" in
652         yum)
653             [ -n "$packages" ] && chroot ${lxc_root} $personality yum -y install $packages
654             for group_plus in $groups; do
655                 group=$(echo $group_plus | sed -e "s,+++, ,g")
656                 chroot ${lxc_root} $personality yum -y groupinstall "$group"
657             done
658             # store current rpm list in /init-lxc.rpms in case we need to check the contents
659             chroot ${lxc_root} $personality rpm -aq > $lxc_root/init-lxc.rpms
660             ;;
661         debootstrap)
662             # for ubuntu
663             if grep -iq ubuntu /vservers/$lxc/etc/lsb-release 2> /dev/null; then
664                 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
665                 # we need at least to add the 'universe' feed for python-rpm
666                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
667                 # also adding a link to updates sounds about right
668                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
669                 # tell apt about the changes
670                 chroot /vservers/$lxc apt-get update
671             fi
672             for package in $packages ; do
673                 # container not started yet
674                 #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get install -y $package" || :
675                 chroot ${lxc_root} $personality apt-get install -y $package || :
676             done
677             ### xxx todo install groups with apt..
678             ;;
679         *)
680             echo "unknown pkg_method $pkg_method"
681             ;;
682     esac
683
684     return 0
685 }
686
687 function post_install () {
688     lxc=$1; shift 
689     personality=$1; shift
690     lxc_root=$(lxcroot $lxc)
691     # setup localtime from the host
692     cp /etc/localtime $lxc_root/etc/localtime
693     sshd_disable_password_auth $lxc
694     # post install hook
695     [ -n "$NAT_MODE" ] && post_install_natip $lxc $personality || post_install_myplc $lxc $personality
696     # start the VM unless specified otherwise
697     if [ -n "$START_VM" ] ; then
698         echo Starting guest $lxc
699         virsh -c lxc:/// start $lxc
700         if [ -n "$NAT_MODE" ] ; then
701             wait_for_ssh $lxc
702         else
703             wait_for_ssh $lxc $GUEST_IP
704         fi
705     fi
706 }
707
708 # just in case, let's stay on the safe side
709 function sshd_disable_password_auth () {
710     lxc=$1; shift 
711     lxc_root=$(lxcroot $lxc)
712     sed --in-place=.password -e 's,^#\?PasswordAuthentication.*,PasswordAuthentication no,' \
713         $lxc_root/etc/ssh/sshd_config
714 }
715
716 function post_install_natip () {
717
718     set -x 
719     set -e 
720     trap failure ERR INT
721
722     lxc=$1; shift
723     personality=$1; shift
724     lxc_root=$(lxcroot $lxc)
725
726 ### From myplc-devel-native.spec
727 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
728     cat << EOF | chroot ${lxc_root} $personality bash -x
729     
730     # customize root's prompt
731     /bin/cat << PROFILE > /root/.profile
732 export PS1="[$lxc] \\w # "
733 PROFILE
734
735 EOF
736         
737 }
738
739 function post_install_myplc  () {
740     set -x 
741     set -e 
742     trap failure ERR INT
743
744     lxc=$1; shift
745     personality=$1; shift
746     lxc_root=$(lxcroot $lxc)
747
748 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
749     cat << EOF | chroot ${lxc_root} $personality bash -x
750
751     # create /etc/sysconfig/network if missing
752     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
753
754     # turn off regular crond, as plc invokes plc_crond
755     /sbin/chkconfig crond off
756
757     # customize root's prompt
758     /bin/cat << PROFILE > /root/.profile
759 export PS1="[$lxc] \\w # "
760 PROFILE
761
762 EOF
763 }
764
765 ########################################
766 # workaround for broken lxc-enter-namespace
767 # 1st version was relying on virsh net-dhcp-leases
768 # however this was too fragile, would not work for fedora14 containers
769 # WARNING: this code is duplicated in lbuild-nightly.sh
770 function guest_ipv4() {
771     lxc=$1; shift
772
773     mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
774     # sanity check
775     [ -z "$mac" ] && return 0
776     arp -en | grep "$mac" | awk '{print $1;}'
777 }
778
779 function wait_for_ssh () {
780     set -x
781     set -e
782
783     lxc=$1; shift
784
785     # if run in public_ip mode, we know the IP of the guest and it is specified here
786     [ -n "$1" ] && { guest_ip=$1; shift; }
787
788     #wait max 2 min for sshd to start 
789     success=""
790     current_time=$(date +%s)
791     stop_time=$(($current_time + 120))
792     
793     counter=1
794     while [ "$current_time" -lt "$stop_time" ] ; do
795          echo "$counter-th attempt to reach sshd in container $lxc ..."
796          [ -z "$guest_ip" ] && guest_ip=$(guest_ipv4 $lxc)
797          [ -n "$guest_ip" ] && ssh -o "StrictHostKeyChecking no" $guest_ip 'uname -i' && { 
798                  success=true; echo "SSHD in container $lxc is UP on IP $guest_ip"; break ; } || :
799          counter=$(($counter+1))
800          sleep 10
801          current_time=$(date +%s)
802     done
803
804     # Thierry: this is fatal, let's just exit with a failure here
805     [ -z $success ] && { echo "SSHD in container $lxc could not be reached (guest_ip=$guest_ip)" ; exit 1 ; } 
806     return 0
807 }
808
809 ####################
810 function failure () {
811     echo "$COMMAND : Bailing out"
812     exit 1
813 }
814
815 function usage () {
816     set +x 
817     echo "Usage: $COMMAND [options] lxc-name             (aka build mode)"
818     echo "Usage: $COMMAND -n hostname [options] lxc-name (aka test mode)"
819     echo "Description:"
820     echo "    This command creates a fresh lxc instance, for building, or running a test myplc"
821     echo "In its first form, spawned VM gets a private IP bridged with virbr0 over dhcp/nat"
822     echo "With the second form, spawned VM gets a public IP bridged on public bridge br0"
823     echo ""
824     echo "Supported options"
825     echo " -n hostname - the hostname to use in container"
826     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
827     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO - current support for fedoras debians ubuntus"
828     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
829     echo " -r repo-url - used to populate yum.repos.d - required in test mode"
830     echo " -P pkgs_file - defines a set of extra packages to install in guest"
831     echo "    by default we use devel.pkgs (build mode) or runtime.pkgs (test mode)"
832     echo " -i image - the location of the rootfs"
833     echo " -m memory - the amount of allocated memory in MB - defaults to $DEFAULT_MEMORY MB"
834     echo " -s do not start VM"
835     echo " -v be verbose"
836     exit 1
837 }
838
839 ### parse args and 
840 function main () {
841
842     #set -e
843     #trap failure ERR INT
844
845     if [ "$(id -u)" != "0" ]; then
846           echo "This script should be run as 'root'"
847           exit 1
848     fi
849
850     START_VM=true
851     while getopts "n:f:d:p:r:P:i:m:sv" opt ; do
852         case $opt in
853             n) GUEST_HOSTNAME=$OPTARG;;
854             f) fcdistro=$OPTARG;;
855             d) pldistro=$OPTARG;;
856             p) personality=$OPTARG;;
857             r) REPO_URL=$OPTARG;;
858             P) PREINSTALLED=$OPTARG;;
859             i) IMAGE=$OPTARG;;
860             m) MEMORY=$OPTARG;;
861             s) START_VM= ;;
862             v) VERBOSE=true; set -x;;
863             *) usage ;;
864         esac
865     done
866         
867     shift $(($OPTIND - 1))
868
869     # parse fixed arguments
870     [[ -z "$@" ]] && usage
871     lxc=$1 ; shift
872     lxc_root=$(lxcroot $lxc)
873
874     # rainchecks
875     almost_empty $lxc_root || \
876         { echo "container $lxc already exists in $lxc_root - exiting" ; exit 1 ; }
877     virsh -c lxc:/// domuuid $lxc >& /dev/null && \
878         { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
879     mkdir -p $lxc_root
880
881     # if IMAGE, copy the provided rootfs to lxc_root
882     if [ -n "$IMAGE" ] ; then
883         [ ! -d "$IMAGE" ] && \
884         { echo "$IMAGE rootfs folder does not exist - exiting" ; exit 1 ; }
885         rsync -a $IMAGE/ $lxc_root/
886     fi
887
888     # check we've exhausted the arguments
889     [[ -n "$@" ]] && usage
890
891     # NAT_MODE is true unless we specified a hostname
892     [ -n "$GUEST_HOSTNAME" ] || NAT_MODE=true
893
894     # set default values
895     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
896     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
897     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
898     [ -z "$MEMORY" ] && MEMORY=$DEFAULT_MEMORY
899     
900     # set memory in KB
901     MEMORY=$(($MEMORY * 1024))
902     
903     # the set of preinstalled packages - depends on mode
904     if [ -z "$PREINSTALLED" ] ; then
905         if [ -n "$NAT_MODE" ] ; then
906             PREINSTALLED=devel.pkgs
907         else
908             PREINSTALLED=runtime.pkgs
909         fi
910     fi
911
912     if [ -n "$NAT_MODE" ] ; then
913         # we can now set GUEST_HOSTNAME safely
914         [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$(echo $lxc | sed -e 's,\.,-,g')
915     else
916         # as this command can be used in other contexts, not specifying
917         # a repo is considered a warning
918         # use -r none to get rid of this warning
919         if [ "$REPO_URL" == "none" ] ; then
920             REPO_URL=""
921         elif [ -z "$REPO_URL" ] ; then
922             echo "WARNING -- setting up a yum repo is recommended" 
923         fi
924     fi
925
926     ##########
927     release=$(echo $fcdistro | cut -df -f2)
928
929     if [ "$personality" == "linux32" ]; then
930         arch=i386
931         arch2=i686
932     elif [ "$personality" == "linux64" ]; then
933         arch=x86_64
934         arch2=x86_64
935     else
936         echo "Unknown personality: $personality"
937     fi
938
939     # compute networking details for the test mode
940     # (build mode relies entirely on dhcp on the private subnet)
941     if [ -z "$NAT_MODE" ] ; then
942
943         #create_bridge_if_needed $PUBLIC_BRIDGE
944         lbuild-bridge.sh $PUBLIC_BRIDGE
945
946         GUEST_IP=$(gethostbyname $GUEST_HOSTNAME)
947         # use same NETMASK as bridge interface br0
948         masklen=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
949         NETMASK=$(masklen_to_netmask $masklen)
950         GATEWAY=$(ip route show | grep default | awk '{print $3}' | head -1)
951         VIF_HOST="vif$(echo $GUEST_HOSTNAME | cut -d. -f1)"
952     fi
953
954     setup_lxc $lxc $fcdistro $pldistro $personality 
955
956     # historically this command is for setting up a build or a test VM
957     # kind of patchy right now though
958     devel_or_test_tools $lxc $fcdistro $pldistro $personality
959
960     # container gets started here
961     post_install $lxc $personality
962     
963     echo $COMMAND Done
964
965     exit 0
966 }
967
968 main "$@"